Index: cpp/frams/genetics/f4/f4_conv.h
===================================================================
--- cpp/frams/genetics/f4/f4_conv.h	(revision 1237)
+++ cpp/frams/genetics/f4/f4_conv.h	(revision 1238)
@@ -5,5 +5,5 @@
 // Copyright (C) 1999,2000  Adam Rotaru-Varga (adam_rotaru@yahoo.com), GNU LGPL
 // Copyright (C) since 2001 Maciej Komosinski
-// 2018, Grzegorz Latosinski, added support for new API for neuron types and development checkpoints
+// 2018, Grzegorz Latosinski, added development checkpoints and support for new API for neuron types
 
 #ifndef _F4_CONV_H_
Index: cpp/frams/genetics/f4/f4_oper.cpp
===================================================================
--- cpp/frams/genetics/f4/f4_oper.cpp	(revision 1237)
+++ cpp/frams/genetics/f4/f4_oper.cpp	(revision 1238)
@@ -18,6 +18,6 @@
 // TODO add support for properties of (any class of) neurons - not just sigmoid/force/intertia (':' syntax) for N
 // TODO add mapping genotype character ranges for neural [connections]
-// TODO change the default branching plane (to match f1) so they do not grow perfectly vertical (cheating vertpos) so easily? (so they require Rr or other modifiers) - verify if and how f4 is different from f1
-// TODO for some genotypes, #defining/undefining F4_SIMPLIFY_MODIFIERS produces significantly different phenotypes (e.g. length of some Joint changes from 1.25 to 1.499, coordinates of Parts change, friction of some part changes from 1.28 to 0.32). Comparing f4_Node trees, the simplification works as intended, there are no huge changes apart from removing contradicting modifiers like 'R' and 'r' or 'L' and 'l', and dispersing the modifiers (changed order). There is no reason for such a significant influence of this. A hypothesis is that something may be wrong with calculating the influence of individual modifiers, e.g. some strong nonlinearity is introduced where it should not be, or some compensation between modifiers that should not influence each other (like L and R), or some modifier f4_Nodes are skipped/ignored when applying? Investigate. Example genotype: /*4*/,i<qlM,C<X>N:*#1>>,r<MRF<Xcm>N:Gpart>#5#1#2MLL#1>#1>>>>#5ML#2L#1>>>Lf,r<#1>rM<CqmLlCfqiFLqXFfl><F,<<XI>iN:|[-1:4.346]><XF><<XrRQ>N:G#3>>QiXFMR>fXM#2MfcR>R#3>>X
+// TODO for some genotypes, #defining/undefining F4_SIMPLIFY_MODIFIERS produces significantly different phenotypes (e.g. length of some Joint changes from 1.25 to 1.499, coordinates of Parts change, friction of some part changes from 1.28 to 0.32). Comparing f4_Node trees, the simplification works as intended, there are no huge changes apart from removing contradicting modifiers like 'R' and 'r' or 'L' and 'l', and dispersing the modifiers (changed order). There is no reason for such a significant influence of this. A hypothesis is that something may be wrong with calculating the influence of individual modifiers, e.g. some strong nonlinearity is introduced where it should not be, or some compensation between modifiers that should not influence each other (like L and R), or some modifier f4_Nodes are skipped/ignored when applying? Investigate. Example genotype that displays this issue: /*4*/,i<qlM,C<X>N:*#1>>,r<MRF<Xcm>N:Gpart>#5#1#2MLL#1>#1>>>>#5ML#2L#1>>>Lf,r<#1>rM<CqmLlCfqiFLqXFfl><F,<<XI>iN:|[-1:4.346]><XF><<XrRQ>N:G#3>>QiXFMR>fXM#2MfcR>R#3>>X
+// TODO The f0 genotypes for /*4*/<<RX>X>X> and RX(X,X) are identical, but if you replace R with Q or C, there are small differences - check why and perhaps unify?
 
 
Index: cpp/frams/genetics/genman.cpp
===================================================================
--- cpp/frams/genetics/genman.cpp	(revision 1237)
+++ cpp/frams/genetics/genman.cpp	(revision 1238)
@@ -476,10 +476,13 @@
 {
 	char buf[50];
-	int len = strlen(g);
+	int len = int(strlen(g));
 	int chars = 0, lines = 0;
 	bool shortened = false;
 	uint32_t *styletab = new uint32_t[len];
 	getFullStyle(g, styletab);
-	string html = "\n<div style=\"background:white;padding:0.2em;font-family:arial,helvetica,sans-serif;font-size:90%\">";
+	string html = "<style>"
+		"span.geno{background:white; padding:0.2em; font-family:arial,helvetica,sans-serif}"
+		"</style>\n\n";
+	html += "<span class=\"geno\">";
 	uint32_t prevstyle, prevcolor, style = 0, color = 0;
 	for (int i = 0; i < len; i++)
@@ -516,5 +519,5 @@
 	html += "</u></b></i></font>";
 	if (shortened) html += " [etc...]";
-	html += "</div>\n";
+	html += "</span>\n";
 	return html;
 }
@@ -533,5 +536,5 @@
 {
 	char buf[50];
-	int len = strlen(g);
+	int len = int(strlen(g));
 	int chars = 0, lines = 0; //currently not used
 	uint32_t *styletab = new uint32_t[len];