Index: cpp/frams/config/f0-SDK.def
===================================================================
--- cpp/frams/config/f0-SDK.def	(revision 1251)
+++ cpp/frams/config/f0-SDK.def	(revision 1252)
@@ -62,5 +62,5 @@
 PROP(hyn,1,0,hinge y negative limit,f,-6.2832,0,-1.5708,hinge_limit_y[0])
 PROP(hyp,1,1024,hinge y positive limit,f,0,6.2832,1.5708,hinge_limit_y[1])
-XPROP(stif,2,0,stiffness,f,0.0,1.0,1.0,stif)
+XPROP(stif,2,0,stiffness,f,0.01,1.0,1.0,stif)
 XPROP(rotstif,2,0,rotation stiffness,f,0.0,1.0,1.0,rotstif)
 PROP(stam,2,0,stamina,f,0.0,1.0,0.25,stamina)
@@ -90,5 +90,5 @@
 PROP(hyn,1,0,hinge y negative limit,f,-6.2832,0,-1.5708,hinge_limit_y[0])
 PROP(hyp,1,1024,hinge y positive limit,f,0,6.2832,1.5708,hinge_limit_y[1])
-XPROP(stif,2,0,stiffness,f,0.0,1.0,1.0,stif)
+XPROP(stif,2,0,stiffness,f,0.01,1.0,1.0,stif)
 XPROP(rotstif,2,0,rotation stiffness,f,0.0,1.0,1.0,rotstif)
 PROP(stam,2,0,stamina,f,0.0,1.0,0.25,stamina)
Index: cpp/frams/config/f0.def
===================================================================
--- cpp/frams/config/f0.def	(revision 1251)
+++ cpp/frams/config/f0.def	(revision 1252)
@@ -62,5 +62,5 @@
 PROP(hyn,1,0,hinge y negative limit,f,-6.2832,0,-1.5708,hinge_limit_y[0])
 PROP(hyp,1,1024,hinge y positive limit,f,0,6.2832,1.5708,hinge_limit_y[1])
-XPROP(stif,2,0,stiffness,f,0.0,1.0,1.0,stif)
+XPROP(stif,2,0,stiffness,f,0.01,1.0,1.0,stif)
 XPROP(rotstif,2,0,rotation stiffness,f,0.0,1.0,1.0,rotstif)
 PROP(stam,2,0,stamina,f,0.0,1.0,0.25,stamina)
@@ -90,5 +90,5 @@
 PROP(hyn,1,0,hinge y negative limit,f,-6.2832,0,-1.5708,hinge_limit_y[0])
 PROP(hyp,1,1024,hinge y positive limit,f,0,6.2832,1.5708,hinge_limit_y[1])
-XPROP(stif,2,0,stiffness,f,0.0,1.0,1.0,stif)
+XPROP(stif,2,0,stiffness,f,0.01,1.0,1.0,stif)
 XPROP(rotstif,2,0,rotation stiffness,f,0.0,1.0,1.0,rotstif)
 PROP(stam,2,0,stamina,f,0.0,1.0,0.25,stamina)
Index: cpp/frams/model/defassign-f0-SDK.h
===================================================================
--- cpp/frams/model/defassign-f0-SDK.h	(revision 1251)
+++ cpp/frams/model/defassign-f0-SDK.h	(revision 1252)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2022  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2023  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
Index: cpp/frams/model/f0-SDK-classes.h
===================================================================
--- cpp/frams/model/f0-SDK-classes.h	(revision 1251)
+++ cpp/frams/model/f0-SDK-classes.h	(revision 1252)
@@ -107,5 +107,5 @@
  {"hyn",1,0,"hinge y negative limit","f -6.2832 0 -1.5708",FIELD(hinge_limit_y[0]),},
  {"hyp",1,1024,"hinge y positive limit","f 0 6.2832 1.5708",FIELD(hinge_limit_y[1]),},
- {"stif",2,0,"stiffness","f 0.0 1.0 1.0",FIELD(stif),},
+ {"stif",2,0,"stiffness","f 0.01 1.0 1.0",FIELD(stif),},
  {"rotstif",2,0,"rotation stiffness","f 0.0 1.0 1.0",FIELD(rotstif),},
  {"stam",2,0,"stamina","f 0.0 1.0 0.25",FIELD(stamina),},
@@ -120,5 +120,5 @@
 {
  {"Extra properties",1,5,"j"},
- {"stif",0,0,"stiffness","f 0.0 1.0 1.0",FIELD(stif),},
+ {"stif",0,0,"stiffness","f 0.01 1.0 1.0",FIELD(stif),},
  {"rotstif",0,0,"rotation stiffness","f 0.0 1.0 1.0",FIELD(rotstif),},
  {"vr",0,0,"red component","f 0.0 1.0 0.5",FIELD(vcolor.x),},
@@ -150,5 +150,5 @@
  {"hyn",1,0,"hinge y negative limit","f -6.2832 0 -1.5708",FIELD(hinge_limit_y[0]),},
  {"hyp",1,1024,"hinge y positive limit","f 0 6.2832 1.5708",FIELD(hinge_limit_y[1]),},
- {"stif",2,0,"stiffness","f 0.0 1.0 1.0",FIELD(stif),},
+ {"stif",2,0,"stiffness","f 0.01 1.0 1.0",FIELD(stif),},
  {"rotstif",2,0,"rotation stiffness","f 0.0 1.0 1.0",FIELD(rotstif),},
  {"stam",2,0,"stamina","f 0.0 1.0 0.25",FIELD(stamina),},
@@ -163,5 +163,5 @@
 {
  {"Extra properties",1,5,"j"},
- {"stif",0,0,"stiffness","f 0.0 1.0 1.0",FIELD(stif),},
+ {"stif",0,0,"stiffness","f 0.01 1.0 1.0",FIELD(stif),},
  {"rotstif",0,0,"rotation stiffness","f 0.0 1.0 1.0",FIELD(rotstif),},
  {"vr",0,0,"red component","f 0.0 1.0 0.5",FIELD(vcolor.x),},