Index: cpp/frams/genetics/fH/fH_general.cpp
===================================================================
--- cpp/frams/genetics/fH/fH_general.cpp	(revision 1256)
+++ cpp/frams/genetics/fH/fH_general.cpp	(revision 1257)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2020  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2023  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -16,7 +16,7 @@
 // Methods for loading handles
 
-const char *fH_part_names[FH_PART_PROPS_COUNT] = { "dn", "fr", "ing", "as" };
-
-const char *fH_joint_names[FH_JOINT_PROPS_COUNT] = { "stif", "rotstif", "stam" };
+const char *fH_part_names[FH_PART_PROPS_COUNT] = { "fr" }; // , "dn", "ing", "as" };
+
+const char *fH_joint_names[FH_JOINT_PROPS_COUNT] = { "stif", "rotstif" }; //, "stam" };
 
 void fH_Handle::loadProperties(Param par)
@@ -376,8 +376,8 @@
 	model->addPart(newpart);
 
-	newpart->density = partprops[0];
-	newpart->friction = partprops[1];
-	newpart->ingest = partprops[2];
-	newpart->assim = partprops[3];
+	newpart->friction = partprops[0]; //Macko 2023-06: TODO partprops[0] is different from par.getDoubleById("fr"); (and par.getDoubleById() is used in createJoint() below, investigate why this difference and whether hardcoded references to fields like here could be avoided? Only use fH_part_names if possible.)
+	//newpart->density = partprops[1];
+	//newpart->ingest = partprops[2];
+	//newpart->assim = partprops[3];
 
 	if (createmapping) newpart->addMapping(ranges);
@@ -399,5 +399,5 @@
 	newjoint->stif = par.getDoubleById("stif");
 	newjoint->rotstif = par.getDoubleById("rotstif");
-	newjoint->stamina = par.getDoubleById("stam");
+	//newjoint->stamina = par.getDoubleById("stam");
 	newjoint->attachToParts(firstpart, secondpart);
 	if (createmapping) newjoint->addMapping(IRange(begin, end));
Index: cpp/frams/genetics/fH/fH_general.h
===================================================================
--- cpp/frams/genetics/fH/fH_general.h	(revision 1256)
+++ cpp/frams/genetics/fH/fH_general.h	(revision 1257)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2020  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2023  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -18,6 +18,6 @@
 #define HANDLE_VECTOR_TYPE "f -1.0 1.0 0.0" ///<Vector values type definition
 #define STICKH_LENGTH_TYPE "f 0.001 1.999 1.0" ///<Length of stick handle. Minimum should not be equal to 0, because calculating direction of next part from current stick with length 0 would be impossible
-#define FH_PART_PROPS_COUNT   4 ///<Count of part properties
-#define FH_JOINT_PROPS_COUNT  3 ///<Count of joint properties
+#define FH_PART_PROPS_COUNT   1 ///<Count of part properties
+#define FH_JOINT_PROPS_COUNT  2 ///<Count of joint properties
 #define FH_PE_NEURO_DET       "d" ///<Id of details type definition in f0_neuro_paramtab
 #define FH_PE_CONN_WEIGHT     "w" ///<Id of weight type definition in f0_neuroconn_paramtab
@@ -118,9 +118,9 @@
  *  - double stif -  joint property of a stick representing stiffness
  *  - double rotstif -  joint property of a stick representing rotation stiffness
- *  - double stamina -  joint property of a stick representing stamina
- *  - double density -  parts property of a stick representing density
+ *  //- double stamina -  joint property of a stick representing stamina
  *  - double friction -  parts property of a stick representing friction
- *  - double ingest -  parts property of a stick representing ingestion
- *  - double assimilation -  parts property of a stick representing assimilation
+ *  //- double density -  parts property of a stick representing density
+ *  //- double ingest -  parts property of a stick representing ingestion
+ *  //- double assimilation -  parts property of a stick representing assimilation
  *  - double length -  length of a stick
  */
Index: cpp/frams/genetics/fH/fH_oper.cpp
===================================================================
--- cpp/frams/genetics/fH/fH_oper.cpp	(revision 1256)
+++ cpp/frams/genetics/fH/fH_oper.cpp	(revision 1257)
@@ -14,11 +14,11 @@
 {
 	{ "Genetics: fH", 1, FH_OPCOUNT + FH_ADD_OPCOUNT, },
-	{ "fH_mut_addition", 0, 0, "Add element", "f 0 1 0.3", FIELD(operations[FH_ADD]), "Probability of adding new element to genotype", },
-	{ "fH_mut_add_joint", 0, 0, " - add joint", "f 0 1 0.33", FIELD(addoperations[FH_ADD_STICK]), "Probability of adding new stick handle", },
-	{ "fH_mut_add_neuron", 0, 0, " - add neuron", "f 0 1 0.33", FIELD(addoperations[FH_ADD_NEURO]), "Probability of adding new neuron handle", },
-	{ "fH_mut_add_connection", 0, 0, " - add neural connection", "f 0 1 0.33", FIELD(addoperations[FH_ADD_CONN]), "Probability of adding new neuron connection handle", },
-	{ "fH_mut_deletion", 0, 0, "Delete element", "f 0 1 0.1", FIELD(operations[FH_DEL]), "Probability of removing element from genotype", },
-	{ "fH_mut_handle", 0, 0, "Modify vectors of handles", "f 0 1 0.3", FIELD(operations[FH_HANDLE]), "Probability of changing values in vectors of handle", },
-	{ "fH_mut_property", 0, 0, "Modify properties of handles", "f 0 1 0.3", FIELD(operations[FH_PROP]), "Probability of changing properties of handles", },
+	{ "fH_mut_addition", 0, 0, "Add element", "f 0 100 30", FIELD(operations[FH_ADD]), "Probability of adding new element to genotype", },
+	{ "fH_mut_add_joint", 0, 0, " - add joint", "f 0 100 33", FIELD(addoperations[FH_ADD_STICK]), "Probability of adding new stick handle", },
+	{ "fH_mut_add_neuron", 0, 0, " - add neuron", "f 0 100 33", FIELD(addoperations[FH_ADD_NEURO]), "Probability of adding new neuron handle", },
+	{ "fH_mut_add_connection", 0, 0, " - add neural connection", "f 0 100 33", FIELD(addoperations[FH_ADD_CONN]), "Probability of adding new neuron connection handle", },
+	{ "fH_mut_deletion", 0, 0, "Delete element", "f 0 100 10", FIELD(operations[FH_DEL]), "Probability of removing element from genotype", },
+	{ "fH_mut_handle", 0, 0, "Modify vectors of handles", "f 0 100 30", FIELD(operations[FH_HANDLE]), "Probability of changing values in vectors of handle", },
+	{ "fH_mut_property", 0, 0, "Modify properties of handles", "f 0 100 30", FIELD(operations[FH_PROP]), "Probability of changing properties of handles", },
 	{ 0, },
 };