Index: cpp/tests/geometry_goals/f1.goal
===================================================================
--- cpp/tests/geometry_goals/f1.goal	(revision 1175)
+++ cpp/tests/geometry_goals/f1.goal	(revision 1263)
@@ -4,24 +4,24 @@
 p:sh=2, sx=0.05, sy=0.5, sz=0.05, vr=0.0, 1.0, 0.0
 p:sh=2, sx=0.05, sy=0.05, sz=0.5, vr=0.0, 0.0, 1.0
-p:y=-0.8995007346349524, -0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
-p:y=-0.8995007346349524, 0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
-p:y=0.8995007346349524, -0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
-p:y=0.8995007346349524, 0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
-p:4.009699, -0.8995007346349524, -0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
-p:4.009699, -0.8995007346349524, 0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
-p:4.009699, 0.8995007346349524, -0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
-p:4.009699, 0.8995007346349524, 0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
-p:2.0048495, sh=2, sx=4.029601229724972, sy=0.05, sz=0.05, rx=0.21773997806084824, -0.09942915321443663, -3.2451101949494454e-17, vr=1.0, 0.0, 0.0
-p:2.0048495, sh=2, sx=0.05, sy=1.8425049309676886, sz=0.05, rx=0.21773997806084824, -0.09942915321443663, -3.2451101949494454e-17, vr=0.0, 1.0, 0.0
-p:2.0048495, sh=2, sx=0.05, sy=0.05, sz=0.9058519381014852, rx=0.21773997806084824, -0.09942915321443663, -3.2451101949494454e-17, vr=0.0, 0.0, 1.0
-p:0.3995, sh=3, sx=0.3995, sy=0.2, sz=0.2, rx=-1.5707963267948966, rz=3.141592653589793
-p:0.7989983479760048, -0.44974999999696585, sh=3, sx=0.44975, sy=0.2, sz=0.2, rz=1.5707926535897934
-p:1.163325, sh=3, sx=0.36432499999999995, sy=0.2, sz=0.2, rx=-1.5707963267948966, rz=3.141592653589793
-p:1.879664, sh=3, sx=0.35201400000000005, sy=0.2, sz=0.2, rx=-1.5707963267948966, rz=3.141592653589793
-p:2.2316764351889136, -0.42600699999712605, sh=3, sx=0.42600699999999997, sy=0.2, sz=0.2, rz=1.5707926535897931
-p:2.657685, sh=3, sx=0.426007, sy=0.2, sz=0.2, rx=-1.5707963267948966, rz=3.141592653589793
-p:3.5466955000000002, sh=3, sx=0.4630035000000001, sy=0.2, sz=0.2, rx=-1.5707963267948966, rz=3.141592653589793
-p:2.2316764351889136, 0.42600699999712605, sh=3, sx=0.42600699999999997, sy=0.2, sz=0.2, rz=-1.5707926535897931
-p:0.7989983479760048, 0.44974999999696585, sh=3, sx=0.44975, sy=0.2, sz=0.2, rz=-1.5707926535897934
+p:y=-0.8325007346354043, -0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
+p:y=-0.8325007346354043, 0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
+p:y=0.8325007346354043, -0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
+p:y=0.8325007346354043, 0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
+p:3.4767959999999998, -0.8325007346354043, -0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
+p:3.4767959999999998, -0.8325007346354043, 0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
+p:3.4767959999999998, 0.8325007346354043, -0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
+p:3.4767959999999998, 0.8325007346354043, 0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
+p:1.7383979999999999, sh=2, sx=3.4997300503918867, sy=0.05, sz=0.05, rx=0.2342831811098684, -0.11454484673768733, -3.443227636570292e-17, vr=1.0, 0.0, 0.0
+p:1.7383979999999999, sh=2, sx=0.05, sy=1.7117636757570973, sz=0.05, rx=0.2342831811098684, -0.11454484673768733, -3.443227636570292e-17, vr=0.0, 1.0, 0.0
+p:1.7383979999999999, sh=2, sx=0.05, sy=0.05, sz=0.8923778124409683, rx=0.2342831811098684, -0.11454484673768733, -3.443227636570292e-17, vr=0.0, 0.0, 1.0
+p:0.3325, sh=3, sx=0.3325, sy=0.2, sz=0.2, rx=-1.5707963267948966, rz=3.141592653589793
+p:0.6649984710283758, -0.41624999999719187, sh=3, sx=0.41624999999999995, sy=0.2, sz=0.2, rz=1.5707926535897934
+p:0.9556250000000001, sh=3, sx=0.290625, sy=0.2, sz=0.2, rx=-1.5707963267948966, rz=3.141592653589793
+p:1.5264060000000002, sh=3, sx=0.28015599999999996, sy=0.2, sz=0.2, rx=-1.5707963267948966, rz=3.141592653589793
+p:1.8065605671634997, -0.3900779999973684, sh=3, sx=0.390078, sy=0.2, sz=0.2, rz=1.5707926535897931
+p:2.19664, sh=3, sx=0.3900779999999999, sy=0.2, sz=0.2, rx=-1.5707963267948966, rz=3.141592653589793
+p:3.031757, sh=3, sx=0.44503899999999996, sy=0.2, sz=0.2, rx=-1.5707963267948966, rz=3.141592653589793
+p:1.8065605671634997, 0.3900779999973684, sh=3, sx=0.390078, sy=0.2, sz=0.2, rz=-1.5707926535897931
+p:0.6649984710283758, 0.41624999999719187, sh=3, sx=0.41624999999999995, sy=0.2, sz=0.2, rz=-1.5707926535897934
 j:0, 1, sh=1
 j:0, 2, sh=1
@@ -48,12 +48,12 @@
 j:0, 15, sh=1
 
-# volume=0.577076
-# area=8.353694
-# sizes.x=4.029601 sizes.y=1.842505 sizes.z=0.905852
-# axes.x=(0.995061, -0.000000, -0.099265)
-# axes.y=(0.021444, 0.976388, 0.214957)
-# axes.z=(0.096922, -0.216024, 0.971566)
-# box.x=[0.000000, 4.009699]
-# box.y=[-0.899501, 0.899501]
+# volume=0.463110
+# area=7.221219
+# sizes.x=3.499730 sizes.y=1.711764 sizes.z=0.892378
+# axes.x=(0.993447, -0.000000, -0.114295)
+# axes.y=(0.026533, 0.972681, 0.230625)
+# axes.z=(0.111172, -0.232146, 0.966307)
+# box.x=[0.000000, 3.476796]
+# box.y=[-0.832501, 0.832501]
 # box.z=[-0.200000, 0.200000]
 