Index: framspy/evolalg/base/experiment_islands_model_abc.py
===================================================================
--- framspy/evolalg/base/experiment_islands_model_abc.py	(revision 1290)
+++ framspy/evolalg/base/experiment_islands_model_abc.py	(revision 1291)
@@ -28,5 +28,5 @@
         sorted_individuals = sorted(
             pool_of_all_individuals, key=lambda x: x.rawfitness)
-        print(f"Best indiviudal for new islands:")
+        print("Best individual for new islands:")
         for i in range(self.number_of_populations):
             shift = i*self.popsize
Index: framspy/evolalg/frams_base/experiment_frams.py
===================================================================
--- framspy/evolalg/frams_base/experiment_frams.py	(revision 1290)
+++ framspy/evolalg/frams_base/experiment_frams.py	(revision 1291)
@@ -7,5 +7,5 @@
 
 class ExperimentFrams(ExperimentABC):
-    def __init__(self, hof_size, popsize, frams_lib, optimization_criteria, genformat, save_only_best=True, constraints={}) -> None:
+    def __init__(self, hof_size, popsize, frams_lib, optimization_criteria, genformat, save_only_best, constraints={}) -> None:
         ExperimentABC.__init__(self, hof_size=hof_size, popsize=popsize, save_only_best=save_only_best)
         self.optimization_criteria = optimization_criteria
Index: framspy/evolalg/tests/test_diferent_settings.py
===================================================================
--- framspy/evolalg/tests/test_diferent_settings.py	(revision 1290)
+++ framspy/evolalg/tests/test_diferent_settings.py	(revision 1291)
@@ -1,4 +1,5 @@
 import argparse
 import sys
+import numpy as np
 
 from FramsticksLib import FramsticksLib
@@ -9,7 +10,9 @@
 from ..numerical_example.numerical_islands_example import ExperimentNumericalIslands
 
-
 from ..utils import ensureDir
 
+
+GENERATIONS = 10 
+
 SETTINGS_TO_TEST_NUMERIC = {
     'hof_size': [0, 10],
@@ -19,5 +22,5 @@
     'pxov': [0.2],
     'tournament': [5],
-    'initialgenotype':[[100, 100, 100, 100], [-100,-100]]
+    'initialgenotype':[np.array([100, 100, 100, 100]), [-100,-100]]
 }
 
@@ -31,5 +34,5 @@
     'migration_interval': [1,5],
     'number_of_populations':[1,5],
-    'initialgenotype':[[100, 100, 100, 100], [-100,-100]]
+    'initialgenotype':[np.array([100, 100, 100, 100]), [-100,-100]]
 }
 
@@ -81,5 +84,5 @@
 
     experiment.evolve(hof_savefile=None,
-                      generations=2,
+                      generations=GENERATIONS,
                       initialgenotype=params['initialgenotype'],
                       pmut=params['pmut'],
@@ -99,5 +102,5 @@
 
     experiment.evolve(hof_savefile=None,
-                      generations=2,
+                      generations=GENERATIONS,
                       initialgenotype=params['initialgenotype'],
                       pmut=params['pmut'],
@@ -117,5 +120,4 @@
                   }
 
-    print('Best individuals:')
     experiment = ExperimentFramsNiching(frams_lib=framsLib,
                                         optimization_criteria=opt_criteria,
@@ -128,8 +130,10 @@
                                         popsize=params['popsize'],
                                         archive_size=params['archive'],
-                                        save_only_best=True)
-
-    experiment.evolve(hof_savefile=None,
-                      generations=2,
+                                        save_only_best=True,
+                                        knn_niching=5,
+                                        knn_nslc=5)
+
+    experiment.evolve(hof_savefile=None,
+                      generations=GENERATIONS,
                       initialgenotype=params['initialgenotype'],
                       pmut=params['pmut'],
@@ -149,5 +153,4 @@
                   }
 
-    print('Best individuals:')
     experiment = ExperimentFramsIslands(frams_lib=framsLib,
                                         optimization_criteria=opt_criteria,
@@ -161,5 +164,5 @@
 
     experiment.evolve(hof_savefile=None,
-                      generations=2,
+                      generations=GENERATIONS,
                       initialgenotype=params['initialgenotype'],
                       pmut=params['pmut'],
@@ -201,6 +204,6 @@
         run_exp(params)
         return [1, None]
-    except Exception as e:
-        return [0, f"Experiment {run_exp.__name__} with params:{params} failied with the stack:{e}"]
+    except Exception as ex:
+        return [0, f"Experiment {run_exp.__name__} with params: {params} failed with the stack: {ex}"]
 
 